<!DOCTYPE HTML>
<html>
  <head>
      <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Documentation Page</title>
    <link rel="stylesheet" href="style.css">
  </head>
  <body>
    <nav id="navbar">
      <header>Flexbox</header>
      <a href="#display:flex" class="nav-link">display:flex</a>
      <a href="#flex-direction" class="nav-link">flex-direction</a>
      <a href="#justify-content" class="nav-link">justify-content</a>
      <a href="#align-items" class="nav-link">align-items</a>
      <a href="#flex-wrap" class="nav-link">flex-wrap</a>
      <a href="#flex-shrink" class="nav-link">flex-shrink</a>
      <a href="#flex-grow" class="nav-link">flex-grow</a>
      <a href="#flex-basis" class="nav-link">flex-basis</a>
      <a href="#flex" class="nav-link">flex</a>
      <a href="#order" class="nav-link">order</a>
      <a href="#align-self" class="nav-link">align-self</a>
    </nav>
    <main id="main-doc">
      <section id="display:flex" class="main-section">
      <header>display:flex</header>
        <p>Placing the CSS property <code>display:flex;</code> on an element allows you to use other flex properties to build a responsive page.</p>
      </section>
      <section id="flex-direction" class="main-section">
      <header>flex-direction</header>
        <p>This makes it possible to align any children of that element into rows or columns. You do this by adding the flex-direction property to the parent item and setting it to row or column.</p>
        
        <ul>
          <li><code>flex-direction:column</code>:Creating a column will align the children vertically</li>
          <li><code>flex-direction:row</code>:Creating a row will align the children horizontally</li>
          
        </ul>
      </section>
      <section id="justify-content" class="main-section">
        <header>justify-content</header>
        <p>Sometimes the flex items within a flex container do not fill all the space in the container. It is common to want to tell CSS how to align and space out the flex items a certain way. Fortunately, the justify-content property has several options to do this. </p>
        <p>Recall that setting a flex container as a row places the flex items side-by-side from left-to-right. A flex container set as a column places the flex items in a vertical stack from top-to-bottom. For each, the direction the flex items are arranged is called the main axis. For a row, this is a horizontal line that cuts through each item. And for a column, the main axis is a vertical line through the items.</p>
        <ul>
       <li> <code>justify-content:center</code> :aligns all the flex items to the center inside the flex container.</li>
       <li> <code>justify-content:flex-start</code> :aligns items to the start of the flex container. For a row, this pushes the items to the left of the container. For a column, this pushes the items to the top of the container.</li>
<li><code>justify-content:flex-end</code> :aligns items to the end of the flex container. For a row, this pushes the items to the right of the container. For a column, this pushes the items to the bottom of the container.</li>
<li><code>justify-content:space-between</code> aligns items to the center of the main axis, with extra space placed between the items. The first and last items are pushed to the very edge of the flex container. For example, in a row the first item is against the left side of the container, the last item is against the right side of the container, then the other items between them are spaced evenly.</li>
<li><code>justify-content:space-around</code> :similar to space-between but the first and last items are not locked to the edges of the container, the space is distributed around all the items </li>
        </ul>
      </section>
      <section id="align-items" class="main-section">
        <header>align-items</header>
        <p>CSS offers the align-items property to align flex items along the cross axis. For a row, it tells CSS how to push the items in the entire row up or down within the container. And for a column, how to push all the items left or right within the container.</p>
        <p>Has flax-start, flex-end and center, like justify-content, and it follows the same logic, but also has new values.</p>
         <ul>
       <li> <code>align-items:stretch</code> :stretch the items to fill the flex container. For example, rows items are stretched to fill the flex container top-to-bottom.</li> 
<li> <code>align-items:baseline</code> :align items to their baselines. Baseline is a text concept, think of it as the line that the letters sit on.</li>
        </ul>
      </section>
      <section id="flex-wrap" class="main-section">
        <header>flex-wrap</header>
        <p>using the flex-wrap property, it tells CSS to wrap items. This means extra items move into a new row or column. The break point of where the wrapping happens depends on the size of the items and the size of the container.</p>
        
        <ul>
          <li><code>flex-wrap:nowrap;</code>:this is the default setting, and does not wrap items.</li>
          <li><code>flex-wrap:wrap;</code>:wraps items from left-to-right if they are in a row, or top-to-bottom if they are in a column.</li>
          <li><code>flex-wrap:wrap-reverse;</code>:wraps items from bottom-to-top if they are in a row, or right-to-left if they are in a column.</li>
        </ul>
      </section>
      <section id="flex-shrink" class="main-section">
        <header>flex-shrink</header>
        <p>The first is the flex-shrink property. When it's used, it allows an item to shrink if the flex container is too small. Items shrink when the width of the parent container is smaller than the combined widths of all the flex items within it.</p>
<p>
The <code>flex-shrink</code> property takes numbers as values. The higher the number, the more it will shrink compared to the other items in the container. For example, if one item has a flex-shrink value of 1 and the other has a flex-shrink value of 3, the one with the value of 3 will shrink three times as much as the other.</p>
        
      </section>
      <section id="flex-grow" class="main-section">
        <header>flex-grow</header>
        <p>The opposite of flex-shrink is the flex-grow property. Recall that flex-shrink controls the size of the items when the container shrinks. The flex-grow property controls the size of items when the parent container expands.</p>
<p>
Using a similar example from the last challenge, if one item has a <code>flex-grow</code> value of 1 and the other has a flex-grow value of 3, the one with the value of 3 will grow three times as much as the other.</p>
        
      </section>
      <section id="flex-basis" class="main-section">
        <header>flex-basis</header>
        <p>The flex-basis property specifies the initial size of the item before CSS makes adjustments with flex-shrink or flex-grow.</p>
<p>
The units used by the flex-basis property are the same as other size properties (px, em, %, etc.). The value auto sizes items based on the content.</p>
        
      </section>
      <section id="flex" class="main-section">
        <header>flex</header>
        <p>There is a shortcut available to set several flex properties at once. The flex-grow, flex-shrink, and flex-basis properties can all be set together by using the flex property.</p>
<p>
For example, <code>flex: 1 0 10px;</code> will set the item to <code>flex-grow: 1;</code>, <code>flex-shrink: 0;</code>, and <code>flex-basis: 10px;</code>.</p>
<p>
The default property settings are <code>flex: 0 1 auto;</code>.</p>
       
      </section>
      <section id="order" class="main-section">
        <header>order</header>
        <p>The <code>order</code> property is used to tell CSS the order of how flex items appear in the flex container. By default, items will appear in the same order they come in the source HTML. The property takes numbers as values, and negative numbers can be used.</p>
        
      </section>
      <section id="align-self" class="main-section">
        <header>align-self</header>
        <p>The final property for flex items is <code>align-self</code>. This property allows you to adjust each item's alignment individually, instead of setting them all at once. This is useful since other common adjustment techniques using the CSS properties float, clear, and vertical-align do not work on flex items.

<code>align-self</code> accepts the same values as <code>align-items</code> and will override any value set by the align-items property.</p>
       
      </section>
    </main>
  </body>
</html>